import java.awt.event.*;
import java.awt.*;
import javax.swing.*;
import java.util.Vector;

public class KMeans extends JApplet
       implements ActionListener, MouseListener{
    KMeansCanvas can;
    KMeansChoice show;
    JButton reset, succ, pred, assign, point;
    Color color;
    Color[] classcolor = {Color.blue, Color.green, Color.red, Color.yellow, Color.cyan, Color.magenta, Color.pink, Color.lightGray,Color.orange, Color.gray, Color.white };
    KMeansAlgo algo;
    boolean crossdot;
    Vector dots, crossdots;

    public KMeans() {
	dots = new Vector();
	crossdots = new Vector();
	JPanel mainframe = new JPanel();
	GridBagLayout gridbag = new GridBagLayout();
	GridBagConstraints constraints = new GridBagConstraints();
	
	algo =new KMeansAlgo();
	crossdot = false;
	mainframe.setLayout(gridbag);

	color = new Color(000000000);
		
	reset = new JButton("Reset");
	buildConstraints(constraints, 0,0,1,1,10,5);
	gridbag.setConstraints(reset, constraints);
	reset.addActionListener(this);
	mainframe.add(reset);

	point = new JButton("Dot");
	buildConstraints(constraints, 1,0,1,1,10,5);
	gridbag.setConstraints(point, constraints);
	point.addActionListener(this);
	mainframe.add(point);

	assign = new JButton("          Start          ");
	buildConstraints(constraints, 2,0,1,1,20,5);
	gridbag.setConstraints(assign, constraints);
	assign.addActionListener(this);
	mainframe.add(assign);
	
	succ = new JButton("+");
	buildConstraints(constraints, 3,0,1,1,10,5);
	gridbag.setConstraints(succ, constraints);
	succ.addActionListener(this);
	mainframe.add(succ);
	
	show = new KMeansChoice();
	buildConstraints(constraints, 4,0,1,1,15,5);
	gridbag.setConstraints(show.label, constraints);
	mainframe.add(show.label);

	pred = new JButton("-");
	buildConstraints(constraints, 5,0,1,1,5,5);
	gridbag.setConstraints(pred, constraints);
	pred.addActionListener(this);
	mainframe.add(pred); 

	can = new KMeansCanvas();
	buildConstraints(constraints, 0,1,6,1,100,100);
	constraints.fill = GridBagConstraints.BOTH;
	gridbag.setConstraints(can, constraints);
	can.setBackground(Color.black);
	can.addMouseListener(this);
	mainframe.add(can);
       

	setContentPane(mainframe);
    }
    
    void buildConstraints(GridBagConstraints gbc, int gx, int gy, int gw, int gh, int wx, int wy) {
	gbc.gridx = gx;
	gbc.gridy = gy;
	gbc.gridwidth = gw;
	gbc.gridheight = gh;
	gbc.weightx = wx;
	gbc.weighty = wy;
    }
     
        
    class KMeansCanvas extends JPanel {
	int x,y;

	public void paintComponent(Graphics g) {
	    super.paintComponent(g);
	   
	    for (int i=0; i < dots.size(); i++) {
		color = classcolor[(int)((Point)dots.get(i)).classcolor];
		g.setColor(color);
		x = (int)((Float)((Point)dots.get(i)).koord.get(0)).floatValue();
		y = (int)((Float)((Point)dots.get(i)).koord.get(1)).floatValue();
		g.fillOval(x-5,y-5,10,10);
	    }
	    if (crossdot == true) {
		for (int j=0; j < crossdots.size(); j++) {
		    if ( ((Crossdot)crossdots.get(j)).dots.size() > 0) {
			x = (int)((Float)((Crossdot)crossdots.get(j)).koord.get(0)).floatValue();
			y = (int)((Float)((Crossdot)crossdots.get(j)).koord.get(1)).floatValue();
			color = classcolor[j];
			g.setColor(color);
			g.fillRect(x-5,y-5,12,12);
		    }
		}
	    }
	}
    }

   
    // zaehlt die KMeans im Menue hoch bzw runter
    class KMeansChoice {
	JLabel label;
	int counter=0;
	
	public KMeansChoice(){
	    label = new JLabel("KMeans: 0", JLabel.CENTER);
	}
	
	public void plus(){
	    if (counter < 10) {
		this.counter +=1; 
		label.setText("KMeans: " + counter);
	    }
	    assign.setText("          Start          ");
	    algo.dotReset(dots,crossdots);
	    crossdot = false;
        }
	
	public void minus(){
	    if (counter > 0) {
		this.counter -=1;
		label.setText("KMeans: " + counter);
		assign.setText("          Start          ");
		algo.dotReset(dots, crossdots);
		crossdot = false;
	    }
	}
    }

           
    public void actionPerformed(ActionEvent evt) {
	Object source = evt.getSource();
	if (source == reset) {
	    color = Color.black;
	    assign.setText("          Start          ");
	    dots.removeAllElements();
	    crossdots.removeAllElements();
	    crossdot = false;
	    repaint();
	}
	else if (source == point) {
	    assign.setText("          Start          ");
	    algo.dotReset(dots, crossdots);
	    crossdot = false;
	    repaint();
	}

	else if (source == succ) {
	    show.plus();
	    repaint();
	}
	else if (source == pred) {
	    show.minus();
	    repaint();
	}
	else if (source == assign) {
	    if (assign.getText() == "          Start          " && show.counter <= dots.size() && show.counter > 0){
		assign.setText("Assign Classes");
	       	algo.getStartClasses(dots, crossdots, show.counter);
		crossdot = true;
		
		repaint();
	    }
	    else if (assign.getText() == "Assign Classes") {
		algo.assignClasses(dots, crossdots);
		assign.setText("   New Classes  ");
		crossdot = true;
		repaint();
	    }
	    else if (assign.getText() == "   New Classes  ") {
		algo.getNewClasses(dots, crossdots);
		assign.setText("Assign Classes");
		crossdot = true;
		repaint();
	    }
	}
    }

    public void mouseClicked(MouseEvent evt) { }
    
    public void mousePressed(MouseEvent evt) {
	Object target = evt.getSource();
	if (target == can && assign.getText() == "          Start          ") {
	    color = Color.white;
	    dots.add(new Point(new Float((float)evt.getX()),new Float((float)evt.getY())));
	    repaint();
	}
    }

    public void mouseReleased(MouseEvent evt) {}

    public void mouseEntered(MouseEvent evt) {}

    public void mouseExited(MouseEvent evt) {}

    public void init() {
	KMeans window = new KMeans();
	window.setVisible(true);
    }
}
    
