import javax.swing.*;
import java.awt.event.*;
import java.awt.*;
import java.util.*;
import java.lang.Math.*;
import java.net.*;
import java.io.*;
import javax.swing.border.*;


public class MLP
    extends JApplet
    implements ActionListener, MouseListener, AdjustmentListener, FocusListener {

  MLPFrame pframe;
  JButton reset, train, forward, backward, open, openWindow;
  MLPAlgo algo = new MLPAlgo();
  Vector input, hidden, output, labels, textin, training;
  JLabel labelin, labelhid, labelout;
  JScrollBar scrollin, scrollhid, scrollout;
  int innr, hidnr, outnr, mousex, mousey;
  JTextArea lessons;
  JPanel box;
  JTextField trainstp, acc;
  JRadioButton trainButton, accn;
  JMenuBar menu;
  JMenu file;
  JMenuItem openFile;
  MlpVisual mlpVisual;
  JFrame dimChoice;
  ButtonGroup xButtons, yButtons;
  JButton visualButton;

  public MLP() {
    JPanel mainframe = new JPanel();
    mainframe.setLayout(new BorderLayout(0, 10));

    input = new Vector();
    hidden = new Vector();
    output = new Vector();
    labels = new Vector();
    textin = new Vector();
    training = new Vector();

    JPanel north = new JPanel();
    north.setLayout(new GridLayout(1, 6));

    openWindow = new JButton("Visualisation");
    openWindow.addActionListener(this);
    north.add(openWindow);

    open = new JButton("Open file");
    open.addActionListener(this);
    north.add(open);

    reset = new JButton("Reset");
    reset.addActionListener(this);
    north.add(reset);

    train = new JButton("Train MLP");
    train.addActionListener(this);
    north.add(train);

    forward = new JButton("Forward");
    forward.addActionListener(this);
    north.add(forward);

    backward = new JButton("Backward");
    backward.addActionListener(this);
    north.add(backward);

    mainframe.add(north, BorderLayout.NORTH);

    JPanel south = new JPanel();
    south.setLayout(new GridLayout(3, 4));

    labelout = new JLabel("OutputNeurons: 01 ", JLabel.CENTER);
    south.add(labelout);
    outnr = 1;

    scrollout = new JScrollBar(JScrollBar.HORIZONTAL, 1, 1, 1, 6);
    scrollout.addAdjustmentListener(this);
    south.add(scrollout);

    south.add(new JLabel(" "));
    south.add(new JLabel(" "));

    labelhid = new JLabel("HiddenNeurons: 02 ", JLabel.CENTER);
    south.add(labelhid);
    hidnr = 2;

    scrollhid = new JScrollBar(JScrollBar.HORIZONTAL, 2, 1, 1, 6);
    scrollhid.addAdjustmentListener(this);
    south.add(scrollhid);

    south.add(new JLabel(" "));
    south.add(new JLabel(" "));

    labelin = new JLabel("InputNeurons    : 02 ", JLabel.CENTER);
    south.add(labelin);
    innr = 2;

    scrollin = new JScrollBar(JScrollBar.HORIZONTAL, 2, 1, 1, 6);
    scrollin.addAdjustmentListener(this);
    south.add(scrollin);

    south.add(new JLabel(" "));
    south.add(new JLabel(" "));

    mainframe.add(south, BorderLayout.SOUTH);

    JPanel east = new JPanel();
    east.setBorder(new TitledBorder("TrainingData"));
    GridBagLayout gridbag = new GridBagLayout();
    GridBagConstraints constraints = new GridBagConstraints();
    east.setLayout(gridbag);

    box = new JPanel();
    lessons = new JTextArea(16, 15);
    lessons.addFocusListener(this);
    lessons.setLineWrap(true);
    box.add(new JScrollPane(lessons));
    buildConstraints(constraints, 0, 0, 3, 1, 50, 50);
    constraints.fill = GridBagConstraints.BOTH;
    gridbag.setConstraints(box, constraints);
    east.add(box);

    ButtonGroup bg = new ButtonGroup();

    trainButton = new JRadioButton("", true);
    buildConstraints(constraints, 0, 1, 1, 1, 1, 1);
    constraints.fill = GridBagConstraints.NONE;
    gridbag.setConstraints(trainButton, constraints);
    trainButton.addActionListener(this);
    bg.add(trainButton);
    east.add(trainButton);

    JLabel trainSteps = new JLabel("Edit Nr. of Trainingsteps: ");
    buildConstraints(constraints, 1, 1, 1, 1, 1, 1);
    gridbag.setConstraints(trainSteps, constraints);
    east.add(trainSteps);

    trainstp = new JTextField("10000", 5);
    buildConstraints(constraints, 2, 1, 1, 1, 5, 10);
    constraints.fill = GridBagConstraints.HORIZONTAL;
    gridbag.setConstraints(trainstp, constraints);
    east.add(trainstp);

    accn = new JRadioButton("", false);
    buildConstraints(constraints, 0, 2, 1, 1, 1, 1);
    constraints.fill = GridBagConstraints.NONE;
    gridbag.setConstraints(accn, constraints);
    accn.addActionListener(this);
    bg.add(accn);
    east.add(accn);

    JLabel accurance = new JLabel("Accurance in % (10-80): ");
    buildConstraints(constraints, 1, 2, 1, 1, 1, 1);
    gridbag.setConstraints(accurance, constraints);
    east.add(accurance);

    acc = new JTextField("50", 2);
    buildConstraints(constraints, 2, 2, 1, 1, 5, 10);
    constraints.fill = GridBagConstraints.HORIZONTAL;
    gridbag.setConstraints(acc, constraints);
    east.add(acc);

    mainframe.add(east, BorderLayout.EAST);

    pframe = new MLPFrame();
    pframe.setBorder(new TitledBorder("MLP"));
    pframe.setLayout(null);
    pframe.setBackground(Color.lightGray);
    pframe.addMouseListener(this);
    mainframe.add(pframe, BorderLayout.CENTER);

    mlpStyle(input, 2, hidden, 2, output, 1, labels, textin);
    algo.initMLP(input, hidden, output);

    setContentPane(mainframe);

    for (int i = 0; i < input.size(); i++) {
      Double input1 = new Double( ( (JTextField) textin.get(i)).getText());
      ( (Neuron) input.get(i)).setOutput(input1.doubleValue());
    }

    algo.doFeedForward(input, hidden, output);

    for (int k = 0; k < output.size(); k++) {
      double x = ( (Neuron) output.get(k)).getOutput();
      ( (JLabel) labels.get(k)).setText("" + Math.floor(x * 1000) / 1000);
    }

    repaint();
  }

  private void buildConstraints(GridBagConstraints gbc, int gx, int gy, int gw,
                                int gh, int wx, int wy) {
    gbc.gridx = gx;
    gbc.gridy = gy;
    gbc.gridwidth = gw;
    gbc.gridheight = gh;
    gbc.weightx = wx;
    gbc.weighty = wy;
  }

  // Paints mainframe and neurons
  class MLPFrame
      extends JPanel {
    int x1, y1, linex1, linex2, liney1, liney2, linevecx, linevecy, checkx,
        checky;
    double checkdiagx = 0, checkdiagy = 0;

    public void paintComponent(Graphics g) {
      super.paintComponent(g);
      g.setColor(Color.black);

      Dimension x = pframe.getSize();
      int max = Math.max(input.size(), hidden.size());
      max = Math.max(max, output.size());

      x1 = (int) x.getWidth() / (max + 1);
      y1 = (int) x.getHeight() / 4;

      //paint neurons and connect them
      for (int i = 0; i < input.size(); i++) {
        ( (JTextField) textin.get(i)).setBounds(x1 * (i + 1), y1 * 3 + 30, 20,
                                                18);
        pframe.add( (JTextField) textin.get(i));
      }

      for (int i = 0; i < input.size(); i++) {
        g.drawOval(x1 * (i + 1), y1 * 3, 20, 20);
      }

      for (int j = 0; j < hidden.size(); j++) {
        g.drawOval(x1 * (j + 1), y1 * 2, 20, 20);
      }

      for (int k = 0; k < output.size(); k++) {
        ( (JLabel) labels.get(k)).setBounds(x1 * (k + 1) - 5, y1 - 20, 40, 18);
        pframe.add( (JLabel) labels.get(k));
        ( (JTextField) textin.get(input.size() + k)).setBounds(x1 * (k + 1) +
            30, y1 - 20, 20, 18);
        pframe.add( (JTextField) textin.get(input.size() + k));
      }

      for (int k = 0; k < output.size(); k++) {
        g.drawOval(x1 * (k + 1), y1, 20, 20);
      }

      for (int i = 0; i < input.size(); i++) {
        for (int j = 0; j < hidden.size(); j++) {
          g.drawLine(x1 * (i + 1) + 10, y1 * 3 - 1, x1 * (j + 1) + 10,
                     y1 * 2 + 21);
        }
      }

      for (int j = 0; j < hidden.size(); j++) {
        for (int k = 0; k < output.size(); k++) {
          g.drawLine(x1 * (j + 1) + 10, y1 * 2 - 1, x1 * (k + 1) + 10, y1 + 21);
        }
      }

      //get weights by clicking on lines
      for (int i = 0; i < input.size(); i++) {
        for (int j = 0; j < hidden.size(); j++) {
          linex1 = x1 * (i + 1) + 10;
          linex2 = x1 * (j + 1) + 10;

          liney1 = y1 * 3 - 1;
          liney2 = y1 * 2 + 21;

          linevecx = linex2 - linex1;
          linevecy = liney2 - liney1;

          checkx = mousex - linex1;
          checky = mousey - liney1;

          if (linevecx != 0)
            checkdiagx = checkx * Math.pow(linevecx, -1);
          else
            checkdiagx = 0;

          checkdiagy = checky * Math.pow(linevecy, -1);

          if ( (Math.max(Math.abs(mousex - linex1), 3) < 4) &&
              (Math.max(Math.abs(mousex - linex2), 3) < 4) &&
              (liney1 - mousey <= Math.abs(linevecy)) && (liney1 - mousey >= 0)) {
            for (int k = 0; k < ( (Neuron) input.get(i)).edgeout.size(); k++) {
              if ( ( (Kante) ( (Neuron) input.get(i)).edgeout.get(k)).getDest() ==
                  hidden.get(j)) {
                Double d = new Double( ( (Kante) ( (Neuron) input.get(i)).
                                        edgeout.get(k)).getWeight());
                g.setColor(Color.blue);
                g.drawString(d.toString(), mousex, mousey);
                g.setColor(Color.black);
              }
            }
          }
          else if ( (Math.abs(checkdiagx) <= 1) && (Math.abs(checkdiagy) <= 1) &&
                   (Math.abs(checkdiagx - checkdiagy) < 0.05) &&
                   (liney1 - mousey <= Math.abs(linevecy)) &&
                   (liney1 - mousey >= 0)) {
            for (int k = 0; k < ( (Neuron) input.get(i)).edgeout.size(); k++) {
              if ( ( (Kante) ( (Neuron) input.get(i)).edgeout.get(k)).dest ==
                  hidden.get(j)) {
                Double d = new Double( ( (Kante) ( (Neuron) input.get(i)).
                                        edgeout.get(k)).getWeight());
                g.setColor(Color.blue);
                g.drawString(d.toString(), mousex, mousey);
                g.setColor(Color.black);
              }
            }
          }
        }
      }

      for (int i = 0; i < hidden.size(); i++) {
        for (int j = 0; j < output.size(); j++) {
          linex1 = x1 * (i + 1) + 10;
          linex2 = x1 * (j + 1) + 10;

          liney1 = y1 * 2 - 1;
          liney2 = y1 + 21;

          linevecx = linex1 - linex2;
          linevecy = liney1 - liney2;

          checkx = linex1 - mousex;
          checky = liney1 - mousey;

          if (linevecx != 0)
            checkdiagx = (mousex - linex1) * Math.pow(linevecx, -1);
          else
            checkdiagx = 0;
          checkdiagy = (mousey - liney1) * Math.pow(linevecy, -1);

          if ( (Math.max(Math.abs(mousex - linex1), 3) < 4) &&
              (checky <= Math.abs(linevecy)) && (checky >= 0) &&
              (Math.max(Math.abs(mousex - linex2), 3) < 4)) {
            for (int k = 0; k < ( (Neuron) hidden.get(i)).edgeout.size(); k++) {
              if ( ( (Kante) ( (Neuron) hidden.get(i)).edgeout.get(k)).getDest() ==
                  output.get(j)) {
                Double d = new Double( ( (Kante) ( (Neuron) hidden.get(i)).
                                        edgeout.get(k)).getWeight());
                g.setColor(Color.blue);
                g.drawString(d.toString(), mousex, mousey);
                g.setColor(Color.black);
              }
            }
          }

          else if ( (Math.abs(checkdiagx) <= 1) && (Math.abs(checkdiagy) <= 1) &&
                   (Math.abs(checkdiagx - checkdiagy) < 0.05) &&
                   (liney1 - mousey <= Math.abs(linevecy)) &&
                   (liney1 - mousey >= 0)) {
            for (int k = 0; k < ( (Neuron) hidden.get(i)).edgeout.size(); k++) {
              if ( ( (Kante) ( (Neuron) hidden.get(i)).edgeout.get(k)).dest ==
                  output.get(j)) {
                Double d = new Double( ( (Kante) ( (Neuron) hidden.get(i)).
                                        edgeout.get(k)).getWeight());
                g.setColor(Color.blue);
                g.drawString(d.toString(), mousex, mousey);
                g.setColor(Color.black);
              }
            }
          }
        }
      }
    }
  }

  public void addTrainData(double x, double y, double ouput) {
    this.lessons.append(""+Math.round(x*100.)/100.+" "+Math.round(y*100.)/100.+" "+ouput+"\n");
    checkInputDimension();
  }

  public void resetMlpDisplay(){
    this.lessons.selectAll();
    this.lessons.replaceSelection("");
    this.lessons.removeAll();
    resetMLP();
    checkInputDimension();
    repaint();
  }

  public void checkInputDimension() {
    if (input.size()>2) {
      if (dimChoice==null) {
        dimChoice = new JFrame("Choose Input-Neurons for ...");
        dimChoice.getContentPane().setLayout(new BorderLayout());

        dimChoice.getContentPane().add(new JLabel("Choose InputVektor for ..."),
                                       BorderLayout.NORTH);

        JPanel center = new JPanel();
        center.setLayout(new GridLayout(2, input.size() + 1));

        center.add(new JLabel("X-Axis: "));
        xButtons = new ButtonGroup();
        for (int i = 0; i < input.size(); i++) {
          JRadioButton rb = new JRadioButton("Neuron " + i);
          rb.setActionCommand("" + i);
          xButtons.add(rb);
          center.add(rb);
        }

        center.add(new JLabel("Y-Axis: "));
        yButtons = new ButtonGroup();
        for (int i = 0; i < input.size(); i++) {
          JRadioButton rb = new JRadioButton("Neuron " + (i + 1));
          rb.setActionCommand("" + i);
          yButtons.add(rb);
          center.add(rb);
        }

        dimChoice.getContentPane().add(center, BorderLayout.CENTER);

        visualButton = new JButton("Ok");
        visualButton.addActionListener(this);
        dimChoice.getContentPane().add(visualButton, BorderLayout.SOUTH);
      }
      dimChoice.setSize(500,300);
      dimChoice.setVisible(true);
    }
    else updateVisualisation(0,1);
  }

  public void updateVisualisation(int x, int y) {
    Vector inData = new Vector();

    try {
      StringTokenizer st = new StringTokenizer(lessons.getText(0,
                    lessons.getLineEndOffset(lessons.getLineCount() - 1)));
      for (int i = 0; i < lessons.getLineCount(); i++) {
        double koord[] = new double[3];
        if (x < y) {
          for (int j = 0; j < x; j++) {
            st.nextToken();
          }

          koord[0] = (new Double(st.nextToken())).doubleValue();

          for (int j = x + 1; j < y; j++) {
            st.nextToken();
          }

          koord[1] = (new Double(st.nextToken())).doubleValue();

          for (int j=y+1; j<input.size(); j++) {
            st.nextToken();
          }

          koord[2] = (new Double(st.nextToken())).doubleValue();

          for (int j = 1; j < output.size(); j++) {
            st.nextToken();
          }
          inData.add(koord);
        }

        else if (x > y) {
          for (int j = 0; j < y; j++) {
            st.nextToken();
          }

          koord[0] = (new Double(st.nextToken())).doubleValue();

          for (int j = y + 1; j < x; j++) {
            st.nextToken();
          }

          koord[1] = (new Double(st.nextToken())).doubleValue();

          for (int j=x+1; j<input.size(); j++) {
            st.nextToken();
          }

          koord[2] = (new Double(st.nextToken())).doubleValue();

          for (int j = 1; j < output.size(); j++) {
            st.nextToken();
          }
          inData.add(koord);
        }
      }
    }
    catch (NoSuchElementException ex) {
      System.out.println("update1: "+ ex);
    }
    catch (Exception e) {
      System.out.println("update2: "+ e);
    }
    mlpVisual.setInData(inData);
  }


  public void actionPerformed(ActionEvent evt) {
    Object source = evt.getSource();

    if (source == reset) {
      if (mlpVisual!=null) checkInputDimension();
      resetMLP();
    }

    else if (source == visualButton) {
      ButtonModel xSelected = xButtons.getSelection();
      ButtonModel ySelected = yButtons.getSelection();

      if (xSelected != null && ySelected!=null && !xSelected.getActionCommand().equals(ySelected.getActionCommand())) {
        int xInput = (new Integer(xSelected.getActionCommand())).intValue();
        int yInput = (new Integer(ySelected.getActionCommand())).intValue();
        System.out.println("xAchse: "+xInput+" yAchse: "+yInput);
        updateVisualisation(xInput,yInput);
      }
    }

    else if (source == openWindow) {
      mlpVisual = new MlpVisual(this);
      checkInputDimension();
    }

    else if (source == forward) {
      for (int i = 0; i < input.size(); i++) {
        Double input1 = new Double( ( (JTextField) textin.get(i)).getText());
        ( (Neuron) input.get(i)).setOutput(input1.doubleValue());
      }

      algo.doFeedForward(input, hidden, output);

      for (int k = 0; k < output.size(); k++) {
        double x = ( (Neuron) output.get(k)).getOutput();
        ( (JLabel) labels.get(k)).setText("" + Math.floor(x * 1000) / 1000);
      }

      if (mlpVisual!=null) checkInputDimension();
      repaint();
    }

    else if (source == backward) {

      for (int i = input.size(); i < input.size() + output.size(); i++) {
        Double input2 = new Double( ( (JTextField) textin.get(i)).getText());
        ( (Neuron) output.get(i - input.size())).setInput(input2.doubleValue());
      }

      algo.doBackPropagation(input, hidden, output);
      algo.doFeedForward(input, hidden, output);

      for (int k = 0; k < output.size(); k++) {
        double x = ( (Neuron) output.get(k)).getOutput();
        ( (JLabel) labels.get(k)).setText("" + Math.floor(x * 1000) / 1000);
      }
      if (mlpVisual!=null) checkInputDimension();
      repaint();
    }

    else if (source == train) {
      StringTokenizer st;
      System.out.println(lessons.getLineCount());
      if (lessons.getLineCount() > 1) {
          if (trainButton.isSelected() == true) {
            int iter = Integer.parseInt(trainstp.getText());
            for (int a = 0; a < iter; a++) {
              try {
                st = new StringTokenizer(lessons.getText(0,
                    lessons.getLineEndOffset(lessons.getLineCount() - 1)));
                for (int i = 0; i < lessons.getLineCount(); i++) {
                  for (int j = 0; j < input.size(); j++) {
                    Double d = new Double(st.nextToken());
                    ( (Neuron) input.get(j)).setOutput(d.doubleValue());
                  }
                  for (int k = 0; k < output.size(); k++) {
                    Double d2 = new Double(st.nextToken());
                    ( (Neuron) output.get(k)).setInput(d2.doubleValue());
                  }

                  algo.doFeedForward(input, hidden, output);
                  algo.doBackPropagation(input, hidden, output);
                }
              }
              catch (NoSuchElementException ex) {
              }
              catch (Exception e) {
                System.out.println(e);
                lessons.insert("Falsche Trainigsformate", 0);
                repaint();
              }
            }

            for (int i = 0; i < input.size(); i++) {
              Double input1 = new Double( ( (JTextField) textin.get(i)).getText());
              ( (Neuron) input.get(i)).setOutput(input1.doubleValue());
            }

            algo.doFeedForward(input, hidden, output);
          }
        }

        else if (accn.isSelected() == true) {
          boolean ok = false;
          Double prec = new Double(acc.getText());

          if (prec.doubleValue() <= 80) {
            try {
              while (ok != true) {
                st = new StringTokenizer(lessons.getText(0,
                    lessons.getLineEndOffset(lessons.getLineCount() - 1)));
                ok = true;
                for (int i = 0; i < lessons.getLineCount(); i++) {
                  for (int j = 0; j < input.size(); j++) {
                    Double d = new Double(st.nextToken());
                    ( (Neuron) input.get(j)).setOutput(d.doubleValue());
                  }
                  for (int k = 0; k < output.size(); k++) {
                    Double d2 = new Double(st.nextToken());
                    ( (Neuron) output.get(k)).setInput(d2.doubleValue());
                  }
                  algo.doFeedForward(input, hidden, output);

                  for (int l = 0; l < output.size(); l++) {
                    double diff = Math.abs( ( (Neuron) output.get(l)).getInput() -
                                            ( (Neuron) output.get(l)).getOutput());
                    if (1 - (prec.doubleValue() / 100) < diff)
                      ok = false;
                  }
                  algo.doBackPropagation(input, hidden, output);
                }
              }
            }
            catch (Exception e) {
              lessons.insert("Falsche Trainigsformate", 0);
              if (mlpVisual!=null) checkInputDimension();
              repaint();
            }
          }

        }

        for (int i = 0; i < input.size(); i++) {
          Double input1 = new Double( ( (JTextField) textin.get(i)).getText());
          ( (Neuron) input.get(i)).setOutput(input1.doubleValue());
        }

        algo.doFeedForward(input, hidden, output);

        for (int k = 0; k < output.size(); k++) {
          double x = ( (Neuron) output.get(k)).getOutput();
          ( (JLabel) labels.get(k)).setText("" + Math.floor(x * 1000) / 1000);
        }

        if (mlpVisual!=null) checkInputDimension();
        repaint();
      }

      else if (source == open) {
        String inputValue = JOptionPane.showInputDialog("Open File:");

            if (inputValue!=null) {
                try {
                    URL url = new URL(getCodeBase()+inputValue);
                    URLConnection con = url.openConnection();
                    BufferedReader br = new BufferedReader(new InputStreamReader(con.getInputStream()));

                    String str;
                    int line = 0;

                    while ((str = br.readLine()) != null) {
                        lessons.append(str);
                        lessons.append("\n");
                    }
                }
                catch (MalformedURLException e) {
                    lessons.insert("Fehler beim Laden",0);
                }
                catch (Exception e) {
                    lessons.insert("Fehler, ev. falscher Dateiname",0);
                }
                if (mlpVisual == null) mlpVisual = new MlpVisual(this);
                checkInputDimension();
            }

        /*try {
          final JFileChooser fileChooser = new JFileChooser();
          int returnVal = fileChooser.showOpenDialog(this);
          if(returnVal == JFileChooser.APPROVE_OPTION){
            String path = fileChooser.getSelectedFile().getAbsolutePath();
            BufferedReader br = new BufferedReader(new FileReader(path));
            String str;
          int line = 0;
          while ( (str = br.readLine()) != null) {
            lessons.append(str);
            lessons.append("\n");
          }
        }
      }
      catch (Exception e) {
        lessons.insert("Fehler: "+e,0);
      }*/
    }
  }

  public void adjustmentValueChanged(AdjustmentEvent evt) {
    JScrollBar source = (JScrollBar) evt.getAdjustable();
    if (source == scrollin) {
      innr = source.getValue();
      labelin.setText("InputNeurons    : 0" + innr);
    }

    else if (source == scrollhid) {
      hidnr = source.getValue();
      labelhid.setText("HiddenNeurons: 0" + hidnr);
    }

    else if (source == scrollout) {
      outnr = source.getValue();
      labelout.setText("OutputNeurons: 0" + outnr);
    }

    for (int i = 0; i < labels.size(); i++) {
      pframe.remove( (JLabel) labels.get(i));
    }

    for (int i = 0; i < textin.size(); i++) {
      pframe.remove( (JTextField) textin.get(i));
    }

    mlpStyle(input, innr, hidden, hidnr, output, outnr, labels, textin);

    resetMLP();
  }

  private void resetMLP() {
    for (int i = 0; i < input.size(); i++) {
      ( (Neuron) input.get(i)).edgein.removeAllElements();
      ( (Neuron) input.get(i)).edgeout.removeAllElements();
    }

    for (int j = 0; j < hidden.size(); j++) {
      ( (Neuron) hidden.get(j)).edgein.removeAllElements();
      ( (Neuron) hidden.get(j)).edgeout.removeAllElements();
    }

    for (int k = 0; k < output.size(); k++) {
      ( (Neuron) output.get(k)).edgein.removeAllElements();
      ( (Neuron) output.get(k)).edgeout.removeAllElements();
    }

    algo.initMLP(input, hidden, output);
    training.removeAllElements();

    for (int i = 0; i < input.size(); i++) {
      Double input1 = new Double( ( (JTextField) textin.get(i)).getText());
      ( (Neuron) input.get(i)).setOutput(input1.doubleValue());
    }

    algo.doFeedForward(input, hidden, output);

    for (int k = 0; k < output.size(); k++) {
      double x = ( (Neuron) output.get(k)).getOutput();
      ( (JLabel) labels.get(k)).setText("" + Math.floor(x * 1000) / 1000);
    }

    repaint();
  }

  //init JTextField and JLabel for Neurons in OutputLayer
  public void mlpStyle(Vector in, int innr, Vector hid, int hidnr, Vector out,
                       int outnr, Vector lab, Vector text) {
    in.removeAllElements();
    hid.removeAllElements();
    out.removeAllElements();
    lab.removeAllElements();
    text.removeAllElements();

    for (int i = 0; i < innr; i++) {
      Neuron n = new Neuron();
      in.add(n);

      JTextField t = new JTextField("0", 3);
      text.add(t);
    }

    for (int j = 0; j < hidnr; j++) {
      Neuron n = new Neuron();
      hid.add(n);
    }

    for (int k = 0; k < outnr; k++) {
      Neuron n = new Neuron();
      out.add(n);

      JLabel l = new JLabel("0.000");
      lab.add(l);

      JTextField t = new JTextField("0", 3);
      text.add(t);
    }
  }

  public void mouseClicked(MouseEvent evt) {
    Object source = evt.getSource();

    if (source == pframe) {
      mousex = evt.getX();
      mousey = evt.getY();
    }

    repaint();
  }

  public void mousePressed(MouseEvent evt) {
    Object source = evt.getSource();

    if (source == pframe) {
      mousex = evt.getX();
      mousey = evt.getY();

    }

    repaint();
  }

  public void focusGained(FocusEvent evt) {}

  public void focusLost(FocusEvent evt) {
    if (mlpVisual != null) checkInputDimension();
  }

  public void mouseMoved(MouseEvent evt) {}

  public void mouseReleased(MouseEvent evt) {}

  public void mouseEntered(MouseEvent evt) {}

  public void mouseExited(MouseEvent evt) {}

  public void init() {
    MLP mlpApplet = new MLP();
    mlpApplet.setVisible(true);
  }
}