/*blabla*/

import javax.swing.*;
import java.awt.event.*;
import java.awt.*;
import java.applet.*;
import java.util.Vector;


public class PerceptronApplet extends Applet{
    MainCanvas canvas;
    DrawControls controls;
    SidePanel sidePanel;
    int dataType=0;
    Vector datapoints = new Vector();
    Perceptron perceptron = new Perceptron();
    Perceptron oldPerceptron = perceptron;
    int currentPoint=-1;
    public boolean afterimage=false;


    public void init() {
        setBackground(Color.white);

        setLayout(new BorderLayout());
        canvas = new MainCanvas(this);
        add("Center", canvas);

        sidePanel = new SidePanel(this);
        add("East",sidePanel);

        controls = new DrawControls(this);
        add("North",controls);




    }

    public void destroy() {
        remove(canvas);
        remove(controls);

    }

    public static void main(String args[]) {
	Frame f = new Frame("PerceptronApplet");
	PerceptronApplet perceptronApplet = new PerceptronApplet();
	perceptronApplet.init();
	perceptronApplet.start();

	f.add("Center", perceptronApplet);
	f.setSize(300, 300);
	f.show();
    }
    public String getAppletInfo() {
        return "Perceptron Demo";
    }

}

class MainCanvas extends Canvas implements MouseListener, MouseMotionListener{
    PerceptronApplet perceptronApplet;

    MainCanvas (PerceptronApplet p) {
        super();
        this.addMouseListener(this);
        this.addMouseMotionListener(this);
        perceptronApplet=p;

        setBackground(Color.white);

    }

    int scaleX(double x1){
        Rectangle r = getBounds();
        return Math.round((float)((x1)*r.width/10)) +r.width/2;

    }
    int scaleY(double y1){
        Rectangle r = getBounds();
        return r.height-Math.round((float)(y1*r.height/10)) -r.height/2;

    }
    double rscaleX(int x1){
        Rectangle r = getBounds();
        return ((double)(x1-r.width/2)/r.width*10);

    }
    double rscaleY(int y1){
        Rectangle r = getBounds();
        return ((double)(r.height-y1-r.height/2)/r.height*10);

    }

    public void mouseClicked(MouseEvent event) {
        //To change body of implemented methods use File | Settings | File Templates.
    }

    public void mouseEntered(MouseEvent event) {
        //To change body of implemented methods use File | Settings | File Templates.
    }

    public void mouseExited(MouseEvent event) {
        perceptronApplet.controls.lx.setText("    ");
        perceptronApplet.controls.ly.setText("    ");
        perceptronApplet.controls.total.setText("    ");

    }

    public void mousePressed(MouseEvent event) {

    }

    public void mouseReleased(MouseEvent e){
        e.consume();
        //Rectangle r = getBounds();
        perceptronApplet.datapoints.addElement( new DataPoint(rscaleX(e.getX()), rscaleY(e.getY()), perceptronApplet.dataType));
        //System.out.println("POINT X:"+e.getX()+" / "+r.width+" = "+((double)e.getX()/r.width)+" Y: "+ e.getY()+" / "+r.height);
        perceptronApplet.currentPoint=-1;
        repaint();


    }
    public void paint(Graphics g) {

        //Rectangle r = getBounds();
        //g.translate(r.width())/2,r.height())/2);

        setBackground(Color.white);

/*
        g.setColor(Color.green);
        g.fillOval(0,0,r.width,r.height);


        int hlines = r.height / 10;
        int vlines = r.width / 10;

        g.setColor(Color.pink);
        for (int i = 1; i <= hlines; i++) {
            g.drawLine(0, i * 10, r.width, i * 10);
        }
        for (int i = 1; i <= vlines; i++) {
            g.drawLine(i * 10, 0, i * 10, r.height);
        }
*/



        int np = perceptronApplet.datapoints.size();


        /* draw the current lines */
        g.setColor(getForeground());
        for (int i=0; i < np; i++) {
            DataPoint p = (DataPoint)perceptronApplet.datapoints.elementAt(i);
            int px=scaleX(p.x);
            int py=scaleY(p.y);

            if (p.dataType==1)  g.setColor(Color.red);
            else g.setColor(Color.blue);
            g.fillOval(px-5, py-5,10,10);

            g.setColor(Color.black);
            if (perceptronApplet.perceptron.isPointWrong(p)) {
                Stroke oldStroke=((Graphics2D) g).getStroke();
                ((Graphics2D) g).setStroke(new BasicStroke(1.5f));

                g.drawLine(px-6, py-6,px+6,py+6);
                g.drawLine(px-6, py+6,px+6,py-6);

                ((Graphics2D) g).setStroke(oldStroke);

            }

            g.setColor(Color.green);
            if (i==perceptronApplet.currentPoint) {
                g.drawOval(px-8, py-8,16,16);
                g.drawOval(px-7, py-7,14,14);
            }
        }

        g.setColor(Color.lightGray);
        Stroke oldStroke=((Graphics2D) g).getStroke();
        ((Graphics2D) g).setStroke(new BasicStroke(2.0f));
        //ERR; LINE VERTICAL-->CRASH
        if (perceptronApplet.afterimage)
           g.drawLine(scaleX(-100),scaleY(perceptronApplet.oldPerceptron.zerolineY(-100)),scaleX(100),scaleY(perceptronApplet.oldPerceptron.zerolineY(100)));
        ((Graphics2D) g).setStroke(oldStroke);


        g.setColor(Color.black);
        oldStroke=((Graphics2D) g).getStroke();
        ((Graphics2D) g).setStroke(new BasicStroke(2.0f));
        //ERR; LINE VERTICAL-->CRASH
        g.drawLine(scaleX(-100),scaleY(perceptronApplet.perceptron.zerolineY(-100)),scaleX(100),scaleY(perceptronApplet.perceptron.zerolineY(100)));
        ((Graphics2D) g).setStroke(oldStroke);

    }

    public void mouseDragged(MouseEvent event) {
        //To change body of implemented methods use File | Settings | File Templates.
    }

    public void mouseMoved(MouseEvent e) {
        perceptronApplet.controls.lx.setText(""+Math.rint(rscaleX(e.getX())*1000)/1000);
        perceptronApplet.controls.ly.setText(""+Math.rint(rscaleY(e.getY())*1000)/1000);
        perceptronApplet.controls.total.setText(""+Math.rint(perceptronApplet.perceptron.equation(rscaleX(e.getX()),rscaleY(e.getY()))*1000) /1000);

    }


}

class DrawControls extends Panel implements ItemListener, ActionListener {
    PerceptronApplet perceptronApplet;
    Checkbox boxBlue,boxRed;
    TextField tw[] = new TextField[3]; //the perceptron weights
    Label lx,ly; //The Point Coordinates
    Label total;
    TextField gamma;
    TextField speed;
    Button buttonXrounds;
    Button buttonXsteps;
    Checkbox boxAfterimage;


     int updateTime = 500; //1000=1s


    Timer roundTimer = new Timer(updateTime, new ActionListener() {
        public void actionPerformed(ActionEvent evt) {
            perceptronApplet.oldPerceptron=perceptronApplet.perceptron.cloneThis();
            perceptronApplet.currentPoint=-1;
            perceptronApplet.perceptron.trainRound(perceptronApplet.datapoints);

            perceptronApplet.canvas.repaint();
            updateText();


            if (!perceptronApplet.perceptron.isVectorWrong(perceptronApplet.datapoints)) {
                perceptronApplet.oldPerceptron=perceptronApplet.perceptron.cloneThis();
                buttonXrounds.setLabel ("x rounds");
                perceptronApplet.canvas.repaint();
                updateText();

                roundTimer.stop();
            }

            roundTimer.setDelay(updateTime);
            stepTimer.stop();
            System.out.println("ROUNDTIMER");
        }
    });

    Timer stepTimer = new Timer(updateTime, new ActionListener() {
        public void actionPerformed(ActionEvent evt) {
            perceptronApplet.oldPerceptron=perceptronApplet.perceptron.cloneThis();
            perceptronApplet.currentPoint++;
            perceptronApplet.currentPoint%=perceptronApplet.datapoints.size();
            if (perceptronApplet.currentPoint>=0)
                perceptronApplet.perceptron.trainStep((DataPoint)perceptronApplet.datapoints.elementAt(perceptronApplet.currentPoint));

            perceptronApplet.canvas.repaint();
            updateText();


            if (!perceptronApplet.perceptron.isVectorWrong(perceptronApplet.datapoints)) {
                perceptronApplet.oldPerceptron=perceptronApplet.perceptron.cloneThis();
                perceptronApplet.currentPoint=-1;
                buttonXsteps.setLabel ("x steps");
                perceptronApplet.canvas.repaint();
                updateText();

                stepTimer.stop();
            }

            stepTimer.setDelay(updateTime);
            System.out.println("STEPTIMER");

        }
    });


    public DrawControls(PerceptronApplet target) {
        this.perceptronApplet = target;
        setLayout(new FlowLayout());
//        setLayout(new BorderLayout());
        setBackground(Color.lightGray);
/*
        TopCtrl topCtrl = new TopCtrl(this);
        add(topCtrl,"North");

        CenterCtrl centerCtrl = new CenterCtrl(this);
        add(centerCtrl,"Center");
*/
        CheckboxGroup group = new CheckboxGroup();

        add(boxBlue = new Checkbox(" 0 ", group, true));
        boxBlue.addItemListener(this);
        //boxBlue.setForeground(Color.blue);
        boxBlue.setBackground(Color.blue);

        add(boxRed = new Checkbox(" 1 ", group, false));
        boxRed.addItemListener(this);
        //boxRed.setForeground(Color.red);
/*
        Choice shapes = new Choice();
        shapes.addItemListener(this);
        shapes.addItem("Lines");
        shapes.addItem("Points");
        shapes.setBackground(Color.lightGray);
        add(shapes);
*/
        Button button;
        add(button = new Button("clear"));
        button.addActionListener(this);
        add(button = new Button("init"));
        button.addActionListener(this);
        add(button = new Button("1 step"));
        button.addActionListener(this);

        buttonXsteps = new Button("x steps");
        add(buttonXsteps);
        buttonXsteps.addActionListener(this);

        add(button = new Button("1 round"));
        button.addActionListener(this);
        add(button = new Button("10 rounds"));
        button.addActionListener(this);
//        add(button = new Button("100 rounds"));
//        button.addActionListener(this);

        buttonXrounds = new Button("x rounds");
        add(buttonXrounds);
        buttonXrounds.addActionListener(this);

        boxAfterimage = new Checkbox("line shadow");
        add(boxAfterimage);
        boxAfterimage.addItemListener(this);

/*
        gamma= new TextField("1.0");
        add(gamma);
        gamma.addActionListener(this);


        for(int i=0; i<3; i++) {
            tw[i] = new TextField("",5);
            add(tw[i]);
            tw[i].addActionListener(this);
        }

        lx=new Label("");
        add(lx);

        ly=new Label("");
        add(ly);
*/


        perceptronApplet.sidePanel.setLayout(new GridLayout(15,1));
        perceptronApplet.sidePanel.setBackground(Color.lightGray);

        Panel row[]=new Panel[15];
        for(int i=0; i<15; i++) {
            row[i]=new Panel();
            row[i].setLayout(new FlowLayout());
            perceptronApplet.sidePanel.add(row[i]);

        }

        row[0].add(new Label("speed"));
        speed= new TextField("1.0");
        row[0].add(speed);
        speed.addActionListener(this);

        row[1].add(new Label("factor"));
        gamma= new TextField("1.0");
        row[1].add(gamma);
        gamma.addActionListener(this);


        row[3].add(new Label("1.000"));

        lx=new Label("0.0000");
        row[4].add(lx);

        ly=new Label("0.0000");
        row[5].add(ly);


        for(int i=0; i<3; i++) {
            tw[i] = new TextField("",5);
            row[i+3].add(tw[i]);
            tw[i].addActionListener(this);
        }

        row[6].add(new Label("_____________"));
        row[7].add(total=new Label("             "));

        updateText();
    }




    public void paint(Graphics g) {
	Rectangle r = getBounds();
	g.setColor(Color.lightGray);
	g.draw3DRect(0, 0, r.width, r.height, false);

        int n = getComponentCount();
        for(int i=0; i<n; i++) {
            Component comp = getComponent(i);
            if (comp==boxRed || comp==boxBlue) {
                Point loc = comp.getLocation();
                Dimension d = comp.getSize();
                if (comp==boxRed) g.setColor(Color.red);
                else g.setColor(Color.blue);
                g.drawRect(loc.x-1, loc.y-1, d.width+1, d.height+1);
            }
        }
    }

    public void itemStateChanged(ItemEvent e) {
//        if (e.getSource() instanceof Checkbox) {
        if (e.getSource()==boxRed) {
            perceptronApplet.dataType=1;
            boxRed.setBackground(Color.red);
            boxBlue.setBackground(null);
        }
        if (e.getSource()==boxBlue) {
            perceptronApplet.dataType=0;
            boxRed.setBackground(null);
            boxBlue.setBackground(Color.blue);

        }
        if (e.getSource()==boxAfterimage) {
            perceptronApplet.afterimage=boxAfterimage.getState();
        }

/*    else if (e.getSource() instanceof Choice) {
      String choice = (String) e.getItem();
      if (choice.equals("Lines")) {
	target.setDrawMode(DrawPanel.LINES);
      } else if (choice.equals("Points")) {
	target.setDrawMode(DrawPanel.POINTS);
      }

    }
*/
        updateText();
    }

    void updateText() {
        for(int i=0; i<3; i++) {
            tw[i].setText(Double.toString(Math.rint(perceptronApplet.perceptron.ww[i]*1000)/1000));
        }
        if (perceptronApplet.currentPoint>=0) {
            DataPoint p = (DataPoint)perceptronApplet.datapoints.elementAt(perceptronApplet.currentPoint);
            lx.setText(""+Math.rint(p.y*1000)/1000);
            ly.setText(""+Math.rint(p.y*1000)/1000);
            total.setText(""+Math.rint(perceptronApplet.perceptron.equation(p.x,p.y)*1000)/1000 );
        }
        else {
            lx.setText("         ");
            ly.setText("         ");
            total.setText("              ");
        }
    }

    public void actionPerformed(ActionEvent e) {
        perceptronApplet.perceptron.gamma=Double.parseDouble(gamma.getText());
        gamma.setText(Double.toString(perceptronApplet.perceptron.gamma));

        perceptronApplet.controls.updateTime=Math.round(500/Float.parseFloat(speed.getText()));

        if (e.getSource() instanceof Button) {
            if (((Button)e.getSource()).getLabel()=="clear") {
                perceptronApplet.datapoints.clear();
                perceptronApplet.canvas.repaint();
            }
            if (((Button)e.getSource()).getLabel()=="init") {
                perceptronApplet.perceptron.init();
                perceptronApplet.oldPerceptron=perceptronApplet.perceptron.cloneThis();
                perceptronApplet.currentPoint=-1;
                perceptronApplet.canvas.repaint();
            }
            if (((Button)e.getSource()).getLabel()=="1 step") {
                perceptronApplet.oldPerceptron=perceptronApplet.perceptron.cloneThis();
                perceptronApplet.currentPoint++;
                perceptronApplet.currentPoint%=perceptronApplet.datapoints.size();
                if (perceptronApplet.currentPoint>=0)
                    perceptronApplet.perceptron.trainStep((DataPoint)perceptronApplet.datapoints.elementAt(perceptronApplet.currentPoint));
                perceptronApplet.canvas.repaint();
            }
            if (((Button)e.getSource()).getLabel()=="1 round") {
                perceptronApplet.oldPerceptron=perceptronApplet.perceptron.cloneThis();
                perceptronApplet.currentPoint=-1;
                perceptronApplet.perceptron.trainRound(perceptronApplet.datapoints);
                perceptronApplet.canvas.repaint();
            }
            if (((Button)e.getSource()).getLabel()=="10 rounds") {
                for (int i=0; i < 10; i++) {
                    perceptronApplet.oldPerceptron=perceptronApplet.perceptron.cloneThis();
                    perceptronApplet.currentPoint=-1;
                    perceptronApplet.perceptron.trainRound(perceptronApplet.datapoints);
                    perceptronApplet.canvas.repaint();
                }
            }
            if (((Button)e.getSource()).getLabel()=="100 rounds") {
                for (int i=0; i < 100; i++) {
                    perceptronApplet.oldPerceptron=perceptronApplet.perceptron.cloneThis();
                    perceptronApplet.currentPoint=-1;
                    perceptronApplet.perceptron.trainRound(perceptronApplet.datapoints);
                    perceptronApplet.canvas.repaint();
                }
            }
        }

        if (e.getSource()==buttonXrounds) {
            if (buttonXrounds.getLabel()=="x rounds") {
                buttonXrounds.setLabel("  STOP  ");
                roundTimer.start();
                System.out.println("START");
            }
            else {
                buttonXrounds.setLabel("x rounds");
                roundTimer.stop();
                System.out.println("STOP");
            }

        }

        if (e.getSource()==buttonXsteps) {
            if (buttonXsteps.getLabel()=="x steps") {
                buttonXsteps.setLabel(" STOP ");
                stepTimer.start();
                System.out.println("START");
            }
            else {
                buttonXsteps.setLabel("x steps");
                stepTimer.stop();
                System.out.println("STOP");
            }

        }

        for(int i=0; i<3; i++) {
            if (e.getSource()==tw[i]) {
                perceptronApplet.perceptron.ww[i]=Double.parseDouble(tw[i].getText());
                perceptronApplet.canvas.repaint();
            }
        }
        updateText();
    }
}


class SidePanel extends Panel{
    PerceptronApplet perceptronApplet;


    TextField tw[] = new TextField[3]; //the perceptron weights
    Label lx,ly; //The Point Coordinates
    TextField gamma;
    TextField speed;

    SidePanel(PerceptronApplet a) {
        perceptronApplet = a ;




    }
}


class DataPoint{
	double x,y;
    int dataType;

	DataPoint(double x1, double y1, int whichType){
		x = x1;
		y = y1;
		dataType = whichType;
        System.out.println("Datapoint "+x1+" "+y1);
	}
}

class Perceptron{
    double ww[]=new double[3];  //weights
    double gamma=1;

    Perceptron(){
        init();
    }

    void init() {
        ww[0]=-Math.random();
        ww[1]=Math.random();
        ww[2]=-Math.random();
        while ((zerolineY(0)<=0.5)==(zerolineY(1)<=0.5)  )  {

            ww[0]=-Math.random();
            ww[1]=Math.random();
            ww[2]=-Math.random();
        }
    }

    void trainRound(Vector datapoints) {
        for (int i=0; i < datapoints.size(); i++) {
            System.out.println("i="+i + " von "+datapoints.size());
            DataPoint p = (DataPoint)datapoints.elementAt(i);

            trainStep(p);

        }
    }

    void trainStep(DataPoint p) {
        if (isPointWrong(p)){
            if (p.dataType==0)  {
                ww[1]-=p.x*gamma;
                ww[2]-=p.y*gamma;
                ww[0]-=1  *gamma;
            }
            else  {
                ww[1]+=p.x*gamma;
                ww[2]+=p.y*gamma;
                ww[0]+=1  *gamma;
            }
            System.out.println("Point: x="+p.x+" y="+p.y+" z="+p.dataType);
            System.out.println("WW:    0="+ww[0]+" 1="+ww[1]+" 2="+ww[2]);
        }

    }

    boolean isVectorWrong(Vector datapoints) {
        for (int i=0; i < datapoints.size(); i++) {
            DataPoint p = (DataPoint)datapoints.elementAt(i);
            if (isPointWrong(p)) return true;
        }
        return false;
    }

    boolean isPointWrong(DataPoint p) {
//        if (p.dataType==0) return (p.x*ww[1]+p.y*ww[2]>=ww[0]);
//        else return (p.x*ww[1]+p.y*ww[2]<ww[0]);
        if (p.dataType==0) return equation(p.x,p.y)>=0;
        else return equation(p.x,p.y)<0;


    }

    double equation(double x, double y) {
        return x*ww[1]+y*ww[2]+1*ww[0];

    }

    Perceptron cloneThis() {
        Perceptron p=new Perceptron();
        for (int i=0 ; i<ww.length;i++)
        p.ww[i] = ww[i];
        p.gamma=gamma;
        return p;

    }

/*    DataPoint lotfusspunk(DataPoint p) {
        DataPoint l;
        double c1;
        double an, bn, cn;
        double r;
        double dist;
        //x*bb-y*aa-c1=0 = x*aa+y*bb-cc
        //x*bb-x*aa=y*aa+y*bb-cc+c1
        //x=(y*aa+y*bb-cc+c1)/(bb-aa)
        //x=Y*(aa+bb)/(bb-aa) - (cc+c1)/(bb-aa)

        //(Y*(aa+bb)/(bb-aa) - (cc+c1)/(bb-aa))*bb-y*aa-c1=0
        //Y*(aa-bb)*bb/(bb-aa) - (cc+c1)/(bb-aa)*bb - y*aa =0
        //

        r=1/(Math.sqrt(aa*aa+bb*bb));
        an=aa*r;
        bn=bb*r;
        cn=cc*r;
        dist = 0 - cn - p.x*an - p.y*bn;


        c1=p.x*bb-p.y*aa;

        //
        // l.x*aa+l.y*bb-cc



        return l;
    }

*/

    double zerolineY(double x1){
        //ERR: division by zero????
        //return (ww[0]-ww[1]*x1)/ww[2];
        return (0-ww[0]-ww[1]*x1)/ww[2];
    }
}

/*
//  px*aa+py*bb=cc
//  x=0:   py*bb=cc    py=cc/bb
//  x=1:  aa+py*bb=cc  py=(cc-aa)/bb
//  p.y=(cc-aa*p.x)/bb  =cc/bb -aa/bb *px

lot(x)=bb/aa *x +c
lot(stzpunktX) =bb/aa * sttzpunktX=sttzpunkY

x*a + y *b =c
x*a + y*b - c =0
*/