import java.util.Vector;
import java.util.Random;

public class KohonenAlgo {
    Neuron neu;
    Random rand;
    
    /** Init KohonenMap */
    public void initKMap(Neuron[][] neur, int mneur, int nneur, int inputnr) {
	rand = new Random();

	for (int i=0; i<mneur; i++) {
	    for (int j=0; j<nneur; j++){
		neu = new Neuron(inputnr, rand.nextInt());
		neur[i][j] = neu;
	    }
	}
    }

    /** Train KohonenMap */
    public void trainMap(Neuron[][] neur, int mneur, int nneur, Vector in, int iterationNr){
	double hrr, e, wr_alt, wr_neu ;
	
	//wr_neu = wr_alt + e * hrr' * (v-wr_alt)
	Vector stimmax = getStimMax(neur, mneur, nneur, in);
	for (int i=0; i<mneur; i++){
	    for (int j=0; j<nneur; j++){
		hrr = getHrr(i,j,((Integer)stimmax.get(1)).intValue(),((Integer)stimmax.get(2)).intValue(),iterationNr);
		e = 10/Math.sqrt(iterationNr);
		for (int k=0; k<in.size(); k++) {
		    wr_alt = ((Kante)((Neuron)neur[i][j]).getInputEdge(k)).getWeight();
		    wr_neu = wr_alt+e*hrr*(((Double)in.get(k)).doubleValue()-wr_alt);
		    ((Kante)((Neuron)neur[i][j]).getInputEdge(k)).setWeight(wr_neu);
		}
	    }
	}
    }

    /** gets Neuron with Maximum of Stimulation */
    public Vector getStimMax(Neuron[][] neu, int mneu, int nneu, Vector in) {
	Vector max = new Vector();
	double sum = 0;

	for (int i=0; i<mneu;i++) {
	    for (int j=0; j<nneu;j++) {
		for (int k=0; k<in.size();k++) {
		    sum = sum + Math.pow((double)((Kante)(neu[i][j]).getInputEdge(k)).getWeight() - ((Double)in.get(k)).doubleValue(),2);
		}
		Math.sqrt(sum);

		if (max.size()==0) {
		    max.add(new Double(sum));
		    max.add(new Integer(i));
		    max.add(new Integer(j));
		}
		else if (((Double)max.get(0)).doubleValue()>sum) {
		    max.removeAllElements();
		    max.add(new Double(sum));
		    max.add(new Integer(i));
		    max.add(new Integer(j));
		}
		sum = 0;
	    }
	}
	return max;
    }	

    public double getHrr(int i, int j, int r1, int r2, int itNr){
	double range;
	double hr;

	range = Math.sqrt(Math.pow(i-r1,2)+Math.pow(j-r2,2));
	hr = Math.exp(-Math.pow(range,2)/(2*Math.pow(20/Math.sqrt(itNr),2)));
	
	return hr;
    }
}
