import java.lang.Math;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.Vector;

public class KNN extends JApplet
    implements ActionListener, MouseListener, MouseMotionListener {

    MyCanvas can;
    JButton red, green, blue, whiteb, succ, pred, reset;
    KMenu show;
    Color color;
    int x, y, minRad, countred, countgreen, countblue;
    boolean whitepressed, mousepressed, start;
    Point dot;
    Vector vec;


    public KNN() {
	color = new Color(000000000);
	start = false;
	x = 0;
	y = 0;
	minRad = 10;
	vec = new Vector();
	
	JPanel frame = new JPanel();
	frame.setLayout(new BorderLayout());
	
	JPanel subframe = new JPanel();
	subframe.setLayout(new GridLayout(1,8,0,0));
	
	reset = new JButton("Reset");
	reset.addActionListener(this);
	subframe.add(reset);
	red = new JButton("Red");
	red.addActionListener(this);
	subframe.add(red);
	green = new JButton("Green");
	green.addActionListener(this);
	subframe.add(green);
	blue = new JButton("Blue");
	blue.addActionListener(this);
	subframe.add(blue);
	succ = new JButton("+");
	succ.addActionListener(this);
	subframe.add(succ);
	show = new KMenu();
	subframe.add(show.label);
	pred = new JButton("-");
	pred.addActionListener(this);
	subframe.add(pred);
	whiteb = new JButton("GetKNN");
	whiteb.addActionListener(this);
	subframe.add(whiteb);

	frame.add("North", subframe);

	can = new MyCanvas();
	can.addMouseListener(this);
	can.addMouseMotionListener(this);
	can.setBackground(Color.black);
	can.setVisible(true);
	frame.add("Center",can);

	setContentPane(frame);
    }

    
    public void getKNN(int koordX, int koordY) {
	boolean ismarked;
	int dotdist = 0;
	int dotX, dotY, remIndex = 0, check;
	
	countred = 0;
	countgreen = 0;
	countblue = 0;
	for (int j=0 ; j<show.counter;j++) {
	    check = 10000;
	    for (int i=0 ; i<vec.size(); i++) {
		dotX = ((Point)vec.get(i)).pointX;
		dotY = ((Point)vec.get(i)).pointY;
		dotdist = Math.round((float)(Math.sqrt(Math.pow(dotX-koordX,2)+Math.pow(dotY-koordY,2))));
		if (dotdist < check && ((Point) vec.get(i)).marked != true) {
		    remIndex = i;
		    check = dotdist;
		}
	    }
	    ((Point)vec.get(remIndex)).setMarked(true);
	    if (((Point)vec.get(remIndex)).dotcolor == Color.red) ++countred;
	    else if (((Point)vec.get(remIndex)).dotcolor == Color.green) ++countgreen;
	    else ++countblue;
	    minRad = check;
	}
	
	for (int i=0; i<vec.size(); i++) ((Point)vec.get(i)).setMarked(false);
    }
    

     private class KMenu {
	JLabel label;
	int counter=0;
	
	private KMenu(){
	    label = new JLabel("KNN: 0", JLabel.CENTER);
	}
	
	private void plus(){
	    this.counter +=1;
	    label.setText("KNN: " + counter);
        }
	
	private void minus(){
	    if (counter > 0) {
		this.counter -=1;
		label.setText("KNN: " + counter);
	    }
	}
    }
    
    
    public class MyCanvas extends JPanel {
	public Dimension getMinimumSize() {
	    return new Dimension (500,400);
	}
	
	public Dimension getPreferredSize() {
		return getMinimumSize();
	}
	
	public void paintComponent(Graphics g){
	    super.paintComponent(g);

	    for (int i=0; i < vec.size(); i++) {
		g.setColor(((Point)vec.get(i)).dotcolor);
		g.fillOval(((Point)vec.get(i)).pointX, ((Point)vec.get(i)).pointY, 10, 10);
	    }

	    if (whitepressed == true){
		g.setColor(color);
		g.drawOval(x-(minRad),y-(minRad),2*minRad+12,2*minRad+12);
	    }
	}
    }
    
    
    private class Point {
	Color dotcolor;
	int pointX , pointY;
	boolean marked;
	
	private Point(int coordX, int coordY, Color color) {
	    pointX = coordX;
	    pointY = coordY;
	    dotcolor=color;
	}
	
	private void setMarked( boolean b) {
	    marked = b;
	}
    }
    
    
    
    public void actionPerformed(ActionEvent evt) {
	Object source = evt.getSource();
	if (source == reset) {
	    color = Color.black;
	    repaint();
	    vec.removeAllElements();
	    whitepressed = false;
	    start = false;
	}
	else if (source == red) {
	    color = Color.red;
	    start = true;
	    whitepressed = false;
	}
	else if (source == green) {
	    color = Color.green;
	    whitepressed = false;
	    start = true;
	}
	else if (source == blue) {
	    color = Color.blue;
	    whitepressed = false;
	    start = true;
	}
	else if (source == succ){
	    show.plus();
	    repaint(0,0,0,0);
	}
	else if (source == pred){
	    show.minus();
	    repaint(0,0,0,0);
	}
	else if (source == whiteb) {
	    color = Color.white;
	    whitepressed = true;
	}
	
    }
    

    
    public void mouseClicked(MouseEvent evt) { }
    
    public void mousePressed(MouseEvent evt) {
	Object target = evt.getSource();

	if ((target == can) && (whitepressed == false)&& (start==true)) {
	    x = evt.getX();
	    y = evt.getY();
	    dot = new Point(x-5,y-5,color);
	    vec.add(dot);
	    repaint();;
	}
	else if (target == can && whitepressed == true && show.counter > 0 && vec.size()>=show.counter) {
	    x = evt.getX();
	    y = evt.getY();
	    this.getKNN(x,y);
	    if (countred > countgreen && countred > countblue) color = Color.red;
	    else if (countgreen > countred && countgreen > countblue) color = Color.green;
	    else if (countblue > countred && countblue > countgreen) color = Color.blue;
	    else color = Color.white;
	    mousepressed = true;
	    repaint();
	}
    }
    
    public void mouseReleased(MouseEvent evt){
	Object target = evt.getSource();
	if (target == can && mousepressed == true){
	    color = Color.black;
	    repaint();
	    mousepressed = false;
	}
    }
    
    public void mouseDragged(MouseEvent evt) {
	Object target = evt.getSource();
	
	if (target == can && whitepressed == true && show.counter > 0 && vec.size()>=show.counter) {
	    x = evt.getX();
	    y = evt.getY();
	    this.getKNN(x,y);
	    if (countred > countgreen && countred > countblue) color = Color.red;
	    else if (countgreen > countred && countgreen > countblue) color = Color.green;
	    else if (countblue > countred && countblue > countgreen) color = Color.blue;
	    else color = Color.white;
	    mousepressed = true;
	    repaint();
	}
	
    }
    
    public void mouseEntered(MouseEvent evt) {}

    public void mouseExited(MouseEvent evt) {}
    
    public void mouseMoved(MouseEvent evt) {}
    

    
    
    public void init() {
	JApplet window = new KNN();
	
	window.setVisible(true);
    }
}
