import java.util.Vector;
import java.util.Date;
import java.util.Random;
import java.lang.Math;
import javax.swing.*;

public class MLPAlgo {
   
    /**Inits MLP, given by InputNeurons in Vector in, HiddenNeurons in Vector hid and OutputNeurons in Vector out */   
    public void initMLP(Vector in, Vector hid, Vector out) {
	Date seed = new Date();
	Random rand = new Random(seed.getTime());
	Kante kant;

	for (int i=0; i < in.size() ; i++) {
	    for (int j=0; j < hid.size(); j++) {
		kant = new Kante((Neuron)in.get(i), (Neuron)hid.get(j),rand.nextDouble());
		((Neuron)in.get(i)).setEdgeOut(kant);
		((Neuron)hid.get(j)).setEdgeIn(kant);
	    }
	}

	for (int i=0; i < hid.size(); i++) {
	    for (int j = 0; j < out.size(); j++) {
		kant = new Kante((Neuron)hid.get(i), (Neuron)out.get(j),rand.nextDouble());
		((Neuron)hid.get(i)).setEdgeOut(kant);
		((Neuron)out.get(j)).setEdgeIn(kant);
	    }
	}
    }
    
    public void doFeedForward(Vector in, Vector hid, Vector out) {
	double sum;
	
	for (int i=0; i < hid.size(); i++){
	    sum = 0;
	    for (int j=0; j < in.size(); j++){
		for (int k=0; k < ((Neuron)in.get(j)).edgeout.size(); k++) {
		    if (((Kante)((Neuron)in.get(j)).edgeout.get(k)).dest == (Neuron)hid.get(i)) {
			sum = sum + ((Kante)((Neuron)in.get(j)).edgeout.get(k)).getWeight()*((Neuron)in.get(j)).getOutput();
		    }
		}
	    }   
	    ((Neuron)hid.get(i)).setOutput(activFunktion(sum));
	}

	for (int j=0; j < out.size(); j++){
	    sum = 0;
	    for (int i=0; i < hid.size(); i++){
		for (int k=0; k < ((Neuron)hid.get(i)).edgeout.size(); k++) {
		    if (((Kante)((Neuron)hid.get(i)).edgeout.get(k)).dest == (Neuron)out.get(j)) {
			sum = sum + ((Kante)((Neuron)hid.get(i)).edgeout.get(k)).getWeight()*((Neuron)hid.get(i)).getOutput();
		    }    
		}
	    }
	    
	    if (sum > 1) ((Neuron)out.get(j)).setOutput(0.999);
	    else if (sum < 0) ((Neuron)out.get(j)).setOutput(0.001);
	    else ((Neuron)out.get(j)).setOutput(sum);
	}  
    }
    
    public void doBackPropagation(Vector in, Vector hid, Vector out) {
	double sum, oi, oj,tj, ok, tk, wjk=0;
	Double dw, dw1;

	//Backpropagation in Output-Layer
	//new weight dw = 0.01 * oi * oj * (1-oj) * (tj-oj) 
	for (int i=0; i < hid.size(); i++) {
	    oi = ((Neuron)hid.get(i)).getOutput();
	    for (int j=0; j < out.size(); j++) {
	        oj = ((Neuron)out.get(j)).getOutput();
		tj = ((Neuron)out.get(j)).getInput();

		if (oj >= 0) {
		    dw = new Double(0.01*oi*oj*(1-oj)*(tj-oj));
		}

		else {
		    dw = new Double(0.01*oi*(-oj)*(1+oj)*(tj+oj));
		}
		
		for (int k=0; k < ((Neuron)hid.get(i)).edgeout.size();k++) {
		    if (((Kante)((Neuron)hid.get(i)).edgeout.get(k)).dest == (Neuron)out.get(j)) {
			double old = ((Kante)((Neuron)hid.get(i)).edgeout.get(k)).getWeight();
			((Kante)((Neuron)hid.get(i)).edgeout.get(k)).setWeight(old + dw.doubleValue());
		    }
		}
	    }
	}

	//Backpropagation in Hidden-Layer
	//new weight dw = 0.01 * oi * oj * (1-oj) * sum
	//sum = summation of: (ok * (1-ok) * (tk-ok) * wjk) which are part of the Output-Layer
	for (int i=0; i < in.size(); i++) {
	    oi = ((Neuron)in.get(i)).getOutput();
	    for (int j=0; j < hid.size(); j++) {
	        sum = 0;
		oj = ((Neuron)hid.get(j)).getOutput();
		for (int k=0; k < out.size(); k++) {
		    ok = ((Neuron)out.get(k)).getOutput();
		    tk = ((Neuron)out.get(k)).getInput();

		    for (int l=0; l < ((Neuron)hid.get(j)).edgeout.size();l++) {
			if (((Kante)((Neuron)hid.get(j)).edgeout.get(l)).dest == (Neuron)out.get(k)) {
			    wjk = ((Kante)((Neuron)hid.get(j)).edgeout.get(l)).getWeight();
			}
		    }		    
		    
		    if (ok >= 0) {
			sum = sum + (ok*(1-ok)*(tk-ok)*wjk);
		    }
		    else sum = sum + ((-ok)*(1+ok)*(tk+ok)*wjk); 
		}

		if (oj > 0 ) {
		    dw1 = new Double(0.01*oi*oj*(1-oj)*sum);
		}
		else  dw1 = new Double(0.01*oi*(-oj)*(1+oj)*sum);

		for (int m=0; m < ((Neuron)in.get(i)).edgeout.size();m++) {
		    if (((Kante)((Neuron)in.get(i)).edgeout.get(m)).dest == (Neuron)hid.get(j)) {
			double old = ((Kante)((Neuron)in.get(i)).edgeout.get(m)).getWeight();
			((Kante)((Neuron)in.get(i)).edgeout.get(m)).setWeight(old + dw1.doubleValue());
		    }
		}
	    }
	}
    }
		
    double activFunktion(double x) {
	double value = (1/(1+Math.exp(-x)));
	return value;
    }
}
	
