import javax.swing.*;
import java.awt.*;
import java.util.Vector;

public class MlpVisual extends JFrame {
  Vector inData;
  PaintBoard board;
  MLP mainWindow;

  public MlpVisual(MLP mlp){
    mainWindow = mlp;
    getContentPane().setLayout(new BorderLayout());
    inData = new Vector();
    board = new PaintBoard();
    this.getContentPane().add(board, BorderLayout.CENTER);
    this.setSize(350,350);
    this.setVisible(true);
  }

  public void setInData(Vector in) {
    inData = in;
    repaint();
  }

  private class PaintBoard extends JPanel{

    private PaintBoard() {
      this.setBackground(Color.black);
    }

    public Dimension getMinimumSize() {
      return new Dimension(350, 350);
    }

    public Dimension getPreferredSize() {
      return getMinimumSize();
    }


    public void paintComponent(Graphics g) {
      g.setColor(Color.black);
      super.paintComponent(g);

      int sizeX = this.getWidth();
      int sizeY = this.getHeight();
      int maxKoordX = 1 * sizeX -80;
      int maxKoordY = 1 * sizeY -80;
      int minKoord = 30;

      //draw Koordinate Axis
      g.setColor(Color.gray);
      g.fillRect(minKoord+5, minKoord-10, 2, maxKoordY+minKoord);
      g.fillRect(minKoord-7, maxKoordY+minKoord+5, maxKoordX+minKoord,2);

      g.fillRect(minKoord-2, minKoord+5, 10, 2);
      g.drawString("1", minKoord-10, minKoord+10);

      g.drawString("0", minKoord-10, maxKoordY+minKoord+20);

      g.fillRect(maxKoordX+minKoord+5, maxKoordY+minKoord+5,2,10);
      g.drawString("1",maxKoordX+minKoord-10,maxKoordY+minKoord+20);

      for (int i = 0; i < inData.size(); i++) {
          double[] koord = (double[]) inData.get(i);
          if (koord[2] > 0.5)
            g.setColor(Color.green);
          else
            g.setColor(Color.red);
          g.fillOval( (int) ( (koord[0] * maxKoordX)+minKoord),
                     (int) ( maxKoordY-(koord[1] * maxKoordY)+minKoord), 10, 10);
      }
      for (int i=minKoord+5; i<=maxKoordY+minKoord+5; i+=5) {
        for (int j=minKoord+5; j<=maxKoordX+minKoord+5; j+=5) {
          ((Neuron)mainWindow.input.get(0)).setOutput((j-minKoord)/(double)maxKoordX);
          ((Neuron)mainWindow.input.get(1)).setOutput((i-minKoord)/(double)maxKoordY);

          mainWindow.algo.doFeedForward(mainWindow.input, mainWindow.hidden, mainWindow.output);


          if (((Neuron)mainWindow.output.get(0)).getOutput()>0.5) g.setColor(Color.green);
            else g.setColor(Color.red);

          g.fillOval(j,maxKoordY-i+70,2,2);
        }
      }

    }
  }

}
